#pragma once
#include <iostream>
#include <string>

class Pizza{
public:
	void Prepare(){
		PrepareDough();
		AddSauce();
		AddAdditions();
		AddSpices();
		Bake();
	}

	void Bake(){
		std::cout << "Wlaczam pieczenie na " + GetBakingTime()  << std::endl;
	}

	virtual void AddSauce(){
		AddTomatoSauce();
	}

	virtual std::string GetBakingTime(){
		return "15 minut";
	}

	virtual void AddSpices() = 0;
	virtual void AddAdditions() = 0;
	virtual void PrepareDough() = 0;

private:
	void AddTomatoSauce(){
		std::cout << "Dodaje sos pomidorowy..." << std::endl;
	}
};
