#pragma once
#include <iostream>
#include "Kaczka.h"
#include "Latanie.h"
#include "Kwakanie.h"

class DzikaKaczka : public Kaczka{
public:
	DzikaKaczka(){
		SetKwakanieInterface(new Kwakanie());
		SetLatanieInterface(new LatamBoMamSkrzyda());
	}

	void Kaczka::Wyswietl(){
		std::cout << "Jestem prawdziw Dzik Kaczk\n";
	}
};

class ModelKaczki : public Kaczka{
public:
	ModelKaczki(){
		SetKwakanieInterface(new Kwakanie());
		SetLatanieInterface(new NieLatam());
	}

	void Kaczka::Wyswietl(){
		std::cout << "Jestem Modelem Kaczki\n";
	}
};

class GumowaKaczka : public Kaczka{
public:
	GumowaKaczka(){
		SetKwakanieInterface(new Piszcz());
		SetLatanieInterface(new NieLatam());
	}

	void Kaczka::Wyswietl(){
		std::cout << "Jestem Gumow Kaczuszk\n";
	}
};