#pragma once
#include <iostream>
#include "ILatanie.h"
#include "IKwakanie.h"

class Kaczka{
private:
	LatanieInterfejs *latanieInterfejs;
	KwakanieInterfejs *kwakanieInterfejs;
public:
	virtual void Wyswietl() = 0;

	void Kaczka::WykonajLec(){
		latanieInterfejs->Lec();
	}
	void Kaczka::WykonajKwakanie(){
		kwakanieInterfejs->Kwacz();
	}

	void Kaczka::Plywaj(){
		std::cout << "Wszystkie kaczki pywaj, nawet te sztuczne!\n";
	}

	void Kaczka::SetLatanieInterface(LatanieInterfejs *latanieInterface){
		this->latanieInterfejs = latanieInterface;
	}
	void Kaczka::SetKwakanieInterface(KwakanieInterfejs *kwakanieInterface){
		this->kwakanieInterfejs = kwakanieInterface;
	}
};