﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SymulatorKaczki.Podejście1
{
    abstract class Kaczka
    {
        public void kwacz()
        {
            Console.WriteLine("Kwa! Kwa!");
        }

        public void pływaj()
        {
            Console.WriteLine("Jestem kaczką więc pływam!");
        }

        public abstract void wyświetl();

        //public void leć()
        //{
        //    Console.WriteLine("Ja latam!");
        //}
    }

    class DzikaKaczka : Kaczka
    {
        public override void wyświetl()
        {
            Console.WriteLine("Jestem dziką kaczką.");
        }
    }

    class PłaskonosKaczka : Kaczka
    {
        public override void wyświetl()
        {
            Console.WriteLine("Jestem kaczką płaskonosą.");
        }
    }

    //class GumowaKaczka : Kaczka
    //{
    //    public void kwacz()
    //    {
    //        Console.WriteLine("Piszczę a nie kwaczę.");
    //    }

    //    public override void wyświetl()
    //    {
    //        Console.WriteLine("Jestem gumową kaczką.");
    //    }
    //}

    class Program
    {
        static int Main(string[] args)
        {
            Kaczka dzika = new DzikaKaczka();
            Kaczka płaskonos = new PłaskonosKaczka();
            dzika.kwacz();
            dzika.wyświetl();
            płaskonos.kwacz();
            płaskonos.wyświetl();
            //Kaczka gumowa = new GumowaKaczka();
            //gumowa.leć();
            //gumowa.wyświetl();
            return 0;
        }
    }
}
