﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SymulatorKaczki.Podejście2
{
    interface ILatające
    {
        void leć();
    }

    interface IKwaczące
    {
        void kwacz();
    }

    abstract class Kaczka
    {
        public void pływaj()
        {
            Console.WriteLine("Pływam!");
        }

        public abstract void wyświetl();
    }

    class DzikaKaczka : Kaczka, ILatające, IKwaczące
    {
        public override void wyświetl()
        {
            Console.WriteLine("Jestem dziką kaczką!");
        }

        public void leć()
        {
            Console.WriteLine("Ja latam!");
        }

        public void kwacz()
        {
            Console.WriteLine("Kwa! Kwa!");
        }
    }

    class GumowaKaczka : Kaczka, IKwaczące
    {
        public override void wyświetl()
        {
            Console.WriteLine("Jestem gumową kaczką!");
        }

        public void kwacz()
        {
            Console.WriteLine("Kwa! Kwa!");
        }
    }

    class WabikKaczka : Kaczka
    {
        public override void wyświetl()
        {
            Console.WriteLine("Jestem wabikiem na kaczki!");
        }
    }

    //class Program
    //{
    //    static int Main(string[] args)
    //    {
    //        Kaczka dzika = new DzikaKaczka();
    //        dzika.pływaj();
    //        IKwaczące dzikaKwacząca = dzika as IKwaczące;
    //        dzikaKwacząca.kwacz();

    //        GumowaKaczka gumowa = new GumowaKaczka();
    //        gumowa.kwacz();
    //        gumowa.wyświetl();
    //        return 0;
    //    }
    //}
}
